# Create scoreboard objectives

scoreboard objectives add chess.value dummy
scoreboard objectives add chess.id dummy
scoreboard objectives add chess.ticks dummy

scoreboard objectives add chess.use_item minecraft.used:minecraft.carrot_on_a_stick
scoreboard objectives add chess.jump minecraft.custom:minecraft.jump
scoreboard objectives add chess.sneak minecraft.custom:minecraft.sneak_time

scoreboard objectives add chess.layer dummy
scoreboard objectives add chess.layer_info dummy
scoreboard objectives add chess.animation dummy
scoreboard objectives add chess.title dummy
scoreboard objectives add chess.laser dummy

scoreboard objectives add chess.start_x dummy
scoreboard objectives add chess.start_y dummy
scoreboard objectives add chess.start_z dummy
scoreboard objectives add chess.end_x dummy
scoreboard objectives add chess.end_y dummy
scoreboard objectives add chess.end_z dummy

scoreboard objectives add chess.wins dummy {"text":"Wins","color":"gold"}
scoreboard objectives setdisplay sidebar chess.wins







# Set constants

scoreboard players set #-1 chess.value -1

scoreboard players set #2 chess.value 2
scoreboard players set #3 chess.value 3
scoreboard players set #5 chess.value 5
scoreboard players set #20 chess.value 20

scoreboard players set #1000 chess.value 1000







# Create teams

team add chess.player
team modify chess.player friendlyFire false







# Create bossbar

bossbar add chess:title {"text":"Pick a side","color":"gold","bold":true}
bossbar set chess:title color blue
bossbar set chess:title max 1
bossbar set chess:title value 1
bossbar set chess:title visible true

bossbar add chess:white {"text":"Your turn","color":"gold","bold":true}
bossbar set chess:white color blue
bossbar set chess:white max 1
bossbar set chess:white value 1
bossbar set chess:white visible true

bossbar add chess:black [{"text":"Your ","color":"gold","bold":true},{"text":"Opponent's","color":"dark_red"},{"text":" turn","color":"gold"}]
bossbar set chess:black color blue
bossbar set chess:black max 1
bossbar set chess:black value 1
bossbar set chess:black visible true







# Prepare world

defaultgamemode adventure
gamerule maxCommandChainLength 2147483647
setworldspawn 4 64 4
forceload add 0 0 15 15







# Increment session

scoreboard players add #global chess.ticks 1







# Reset game

scoreboard players set #reset_game chess.value 1