# Set turn score

scoreboard players operation #cursor_player chess.id = #black_player chess.id

scoreboard players set #cursor_mode chess.value 1
scoreboard players set #cursor_mode_update chess.value 1







# Modify bossbars

bossbar set chess:white name [{"text":"Your ","color":"gold","bold":true},{"text":"Opponent's","color":"dark_red"},{"text":" turn","color":"gold"}]
bossbar set chess:black name [{"text":"Your turn","color":"gold","bold":true}]







# Reset board

function chess:generic/reset_board







# Remove particle tags

tag @e[type=block_display,tag=chess_piece] remove particle







# Mark friends and foes

tag @e[type=block_display,tag=chess_piece] remove friend
tag @e[type=block_display,tag=chess_piece] remove foe

tag @e[type=block_display,tag=chess_piece,tag=white] add foe
tag @e[type=block_display,tag=chess_piece,tag=black] add friend







# Mark friend king

tag @e[type=block_display,tag=chess_piece] remove friend_king

tag @e[type=block_display,tag=chess_piece,tag=friend,tag=king] add friend_king







# Remove en passant tag

tag @e[type=block_display,tag=chess_piece,tag=friend,tag=pawn] remove en_passant







# Reset data layers

fill 0 61 0 7 62 7 white_concrete







# Mark data layer for dangerous locations

function chess:phase/2/data/danger/main







# Check for in check

scoreboard players set #check chess.value 0
execute at @e[type=block_display,tag=chess_piece,tag=friend,tag=king] if block ~ 61 ~ red_concrete run scoreboard players set #check chess.value 1







# Mark en passant shields

execute as @e[type=block_display,tag=chess_piece,tag=friend,tag=king] at @s run function chess:phase/2/data/en_passant/main







# Mark shields

execute as @e[type=block_display,tag=chess_piece,tag=friend,tag=king] at @s run function chess:phase/2/data/shield/main







# Count and mark active threats

execute if score #check chess.value matches 1 as @e[type=block_display,tag=chess_piece,tag=friend,tag=king] at @s run function chess:phase/2/data/threat/main







# Count valid moves

scoreboard players set #movement_count chess.value 0
scoreboard players set #movement_count_bool chess.value 1

function chess:phase/2/data/movement/main

scoreboard players set #movement_count_bool chess.value 0







# Apply game state

execute if score #movement_count chess.value matches 1.. if score #check chess.value matches 1 run function chess:phase/2/state/check
execute if score #movement_count chess.value matches 000 if score #check chess.value matches 0 run function chess:phase/2/state/stalemate
execute if score #movement_count chess.value matches 000 if score #check chess.value matches 1 run function chess:phase/2/state/checkmate

execute unless entity @e[type=block_display,tag=chess_piece,tag=friend,tag=king] run function chess:phase/2/state/checkmate